<template>
  <div>
    <!-- Navegador -->
    <!-- <AppNav></AppNav> -->
    <!-- Cuerpo -->
    <div style="margin: 0 12rem" class="padding-top">
      <el-header height="210px">
        <!-- Regresar a parrilla CON modal -->
        <ReturnButton v-if="oneDay" v-on:clickEvent="returnButtonModal = true" title="Ir a la Parrilla" :offsetArrow="20" :spanTitle="3" class="text-end"></ReturnButton>
        <!-- Regresar a parrilla SIN modal -->
        <ReturnButton v-else v-on:clickEvent="returnToGrill(objFromGrid)" title="Ir a la Parrilla" :offsetArrow="20" :spanTitle="3" class="text-end"></ReturnButton>

        <AppModalReturn :show-dialog.sync="returnButtonModal" v-if="returnButtonModal" v-on:btnEvent="returnButtonModal = false" @btnEvent="returnToGrill(objFromGrid)" v-on:eventBtn="returnButtonModal = false">
        </AppModalReturn>

        <img src="../../assets/images/titulo-cortes.png" alt="titulo-cortes" style="margin: 2rem 0;">
        <!-- Titulo del Programa -->
        <el-col :span="24">
          <div class="color-gray titleCuts">{{ this.objFromGrid.programInfo.programTitle }}</div>
        </el-col>
      </el-header>
      <el-main style="padding: 4rem 3rem">
        <!-- Seleccionar día -->
        <p class="color-gray">Seleccione el día que va a editar los cortes:</p>      
        <el-select style="margin: 1.5rem 0"
          v-model="oneDay"
          @change="handleSelect()"
          >
          <el-option
            v-for="(item, index) in this.objFromGrid.arrOfDays"
            :key="index"
            :label="item.day"
            :value="item.numberOfDay">
          </el-option>
        </el-select>
        <div v-for="(cap, i) in capsByDay" :key="i">
          <br>
          <h3 class="text-orange" style="margin: 2rem 0" v-if="cap.chapter !== ''">CORTES DEL CAPÍTULO {{cap.chapter}}:</h3>
          <h3 class="text-orange" style="margin: 2rem 0" v-else>CORTES DEL MATERIAL:</h3>
          <!-- DURACION DEL PROGRAMA -->
          <el-row style="margin-bottom: 2rem">
            <el-col :span="5" class="fonts-bold-general" style="padding-top: 7px;">
              <span v-if="cap.chapter !== ''">Duración del Capítulo:</span>
              <span v-else>Duración del Material:</span>
            </el-col>
            <el-col :span="3" :offset="1">
              <el-input v-model="cap.duration" :ref="`duration-${i}`" @focus="savingPreviousDuration(cap.duration)" type="time" step="2" size="small" @blur="recalculateArtisticDuration(cap.cuts, cap.duration, i)"></el-input>
            </el-col>
          </el-row>
          <!-- DURACION ARTISTICA -->
          <el-row style="margin-bottom: 2rem">
            <el-col :span="5" class="fonts-bold-general" style="padding-top: 7px;">
              <span>Duración artística:</span>
            </el-col>
            <el-col :span="3" :offset="1">
              <el-input v-model="cap.artisticDuration" type="time" step="2" size="small" :disabled="true"></el-input>
            </el-col>
          </el-row>

          <!-- Tiempo y N° de cortes -->
          <el-row style="margin-bottom: 3rem">
            <el-col :span="7">
              <el-col :span="11" class="fonts-bold-general" style="padding-top: 7px;"><span>N° de Cortes:</span></el-col>
              <el-col :span="6"><el-input v-model="cap.numberOfCuts" maxlength="3" size="small" @keyup.enter.native="$refs.jump1.focus" v-on:keypress.native="isNumber" :disabled="inputsActive"></el-input></el-col>
            </el-col>
            <el-col :span="17">
              <el-col :span="6" class="fonts-bold-general" style="padding-top: 7px;"><span>Tiempo de Corte:</span></el-col>
              <el-col :span="2"><el-input v-model="cap.timeOfCut" maxlength="2" size="small" ref="jump1" @keyup.enter.native.prevent="makeCuts(cap.timeOfCut, cap.numberOfCuts, cap.artisticDuration, i, cap.duration)" v-on:keypress.native="isNumber" :disabled="inputsActive"></el-input></el-col>
            </el-col>
          </el-row>

          <!-- Tabla de cortes -->
          <el-row style="margin-bottom: 1rem">
            <el-col :span="20">
              <el-col :span="3" class=" text-white bg-dark-gray-2" style="padding: 0.6rem 1rem">Corte:</el-col>
              <el-col :span="5" class=" text-white bg-dark-gray-2" style="padding: 0.6rem 0">T.C. Inicio:</el-col>
              <el-col :span="4" class=" text-white bg-dark-gray-2" style="padding: 0.6rem 0">Duración:</el-col>
              <el-col :span="4" class=" text-white bg-dark-gray-2" style="padding: 0.6rem 1rem">T.C. Fin:</el-col>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="18" style="margin: 0 0 0.6rem"
              v-for="(cutTime, index) in cap.cuts"
              :key="index">
              <el-col :span="2" style="margin-right:2rem">
                <div class="cutIndex">{{cutTime.id}}</div>
              </el-col>
              <el-col :span="4" style="margin-right:2rem"><el-input v-model="cutTime.start" type="time" step="2" size="small" @blur="calculateTimeEnd(index, i, cap.cuts, cap.duration)"></el-input></el-col>
              <el-col :span="4" style="margin-right:2rem"><el-input v-model="cutTime.duration" type="time" step="2" size="small" @blur="calculateTimeEnd(index, i, cap.cuts, cap.duration)"></el-input></el-col>
              <el-col :span="4" style="margin-right:1rem"><el-input v-model="cutTime.end" type="time" step="2" size="small" @blur="calculateTimeEnd(index, i, cap.cuts, cap.duration)" :disabled="true"></el-input></el-col>
              <el-col :span="1"><i @click="addCuts(index, cap.cuts, i)" class="el-icon-circle-plus text-orange" style="font-size:25px; cursor: pointer;"></i></el-col>
              <el-col :span="1"><i @click="removeCut(index, cap.cuts, i)" class="el-icon-remove text-gray" style="font-size:25px; cursor: pointer;"></i></el-col>
            </el-col>
          </el-row>
          <br>
          <hr v-if="i !== capsByDay.length -1">
        </div>

        <!-- Botones de cancelar y actualizar -->
        <div style="margin: 7rem 0 0" class="text-end">
          <el-button v-on:click="modalCancelButton = true" class="text-orange border-orange" plain>CANCELAR</el-button>
          <el-button @click="validateDurationProgram(objFromGrid)" type="primary" style="margin-left: 3rem">ACTUALIZAR</el-button>
        </div>
        <!-- Modal botón cancelar -->
        <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton" v-on:btnEvent="returnToGrill(objFromGrid)"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
        </AppModalDanger>
        <AppModal 
          ref="showModal"
          v-if="messageExist"
          :show-dialog.sync="messageExist"
          :parrafo=" textShow "
          :styleBox="true"
          nameClass="dialog-red"
          :rutImg="require('@/assets/images/alerta.svg')" sizeImg="60px"
        ></AppModal>
        <AppModal :show-dialog.sync="exceedsProgramDuration" v-if="exceedsProgramDuration" nameClass="dialog-red" 
          :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%"  
          :parrafo="exceedsDurationText">
        </AppModal>
        <AppModal :show-dialog.sync="noDurationValid" v-if="noDurationValid" nameClass="dialog-red" 
          :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%"  
          :parrafo="noDurationValidText">
        </AppModal>
        <AppModal :show-dialog.sync="durationOfDaysInvalid" v-if="durationOfDaysInvalid" nameClass="dialog-red" 
          :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%" :parrafo="durationOfDaysInvalidText">
        </AppModal>
        <AppModal :show-dialog.sync="validateCutsOfChapter" v-if="validateCutsOfChapter" nameClass="dialog-red" 
          :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%" :parrafo="validateCutsOfChapterText">
        </AppModal>

        <el-dialog :visible.sync="alertPrevToSave" width="33%" :show-close="false" custom-class="dialog-red"
          :close-on-press-escape="false" :close-on-click-modal="false"> 
          <el-row style="display: flex; align-items: center;">
            <el-col :span="5" class="text-center">
              <img :src="require(`../../assets/images/alerta.svg`)" alt="emoticon" width="80px">
            </el-col>
            <el-col :span="18" :offset="1">
              <p>Por favor, espere mientras se guarda la información...</p>
            </el-col>
          </el-row>
        </el-dialog>
        <!-- ACTUALIZAR DATA -->
        <AppModalSuccess :show-dialog.sync="modalUpdateToGoBack" v-if="modalUpdateToGoBack" :styleModal="true"
          :parrafo="'Se han actualizado correctamente los cortes.'"
          btn1="OK" @btnEvent="returnToGrill(objFromGrid)" >
        </AppModalSuccess>

      </el-main>
    </div>
  </div>
</template>

<script>
// import AppNav from '@/components/AppNav.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import AppModalReturn from '@/components/AppModalReturn.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import AppModal from '@/components/AppModal.vue'
import { addTimes, restTimes } from '../../utils/calculateTime.js'
import { HTTP } from '../../main.js'
import AppModalSuccess from '@/components/AppModalSuccess.vue'

export default {
  components: {
    AppModalReturn,
    ReturnButton,
    AppModalDanger,
    AppModal,
    AppModalSuccess,
  },
  data () {
    return {
      oneDay: '',
      objFromGrid: {},
      arrOfDailyCuts: [], // Cambiar en este array como en los datos de abajo
      programDuration: '',
      artisticDuration: '',
      numberOfCuts: '',
      timeOfCut: '',
      arrCuts: [],
      returnButtonModal: false,
      modalCancelButton: false,
      typeChannel: this.$route.params.type,
      inputsActive: true,
      textShow: '',
      messageExist: false,
      cutsProgramInitialValue: '',
      capsByDay: [],
      codeMaterialSelected: '',
      exceedsDurationText: 'Se ha excedido la duración del programa.',
      exceedsProgramDuration: false,
      previousDuration: '',
      noDurationValid: false,
      noDurationValidText: 'La duración no es válida.',
      daysOfProgram: '',
      daysWithClosureOrcl: [],
      durationOfDaysInvalid: false,
      durationOfDaysInvalidText: '',
      validateCutsOfChapter: false,
      validateCutsOfChapterText: '',
      alertPrevToSave: false,
      modalUpdateToGoBack: false,
      indexOfObjOfGrid: '',
    }
  },
  computed: {
  },
  created () {
    this.programObj()
  },
  methods: {
    programObj () {
      let grid = JSON.parse(this.$localStorage.get("gridPayload"));
      let days = grid.dataSentence;
      let cards = grid.cardsData;
      let filtArr = []

      filtArr = cards.filter(function(item) {
        return item !== 0
      })

      filtArr.map((el,i,arr) => {
        if(el === 0) {
          arr.splice(i, 1);
        } else {
          el.completeDate = days[i]
        }
      })

      grid.cardsData = filtArr;
      this.objFromGrid = grid
      // OBTENER DIAS COMPLETOS DE TRANSMISION
      this.daysOfProgram = this.objFromGrid.cardsData.map((day, i, arr) => {
        day.isModification = false
        return day.completeDate
      })
      console.log(this.objFromGrid.cardsData, 'this.objFromGrid 2221')
      this.getDaysWithClosureOcl(this.daysOfProgram)
    },
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }      
    },
    returnToGrill(programObj) {
      this.$localStorage.set('programedProgram', JSON.stringify(programObj))
      this.$router.push({name: 'gridContent', params: {type: this.typeChannel}})
    },
    savingPreviousDuration(value){
      this.previousDuration = value
    },
    recalculateArtisticDuration (cutsOfChapter, newValue, index){
      this.$localStorage.set('cutsOfChapter', JSON.stringify(cutsOfChapter))
      // VALIDA QUE LA DURACION DE LOS CAPITULOS NO SEAN SEGUNDOS
      let durationChapterSelected = this.capsByDay[index].duration.split(':')
      let durationInSeconds = Number((durationChapterSelected[0]*60)*60)+Number(durationChapterSelected[1]*60)+ Number(durationChapterSelected[1])
      if(durationInSeconds<60){
        this.noDurationValid = true
        this.capsByDay[index].duration = this.previousDuration
        return false
      }

      // VALIDA SI LA DURACION DE LOS CAPITULOS EXCEDE LA DURACION DEL PROGRAMA EN EL DIA
      let totalDurationDay = ''
      this.capsByDay.map((capData)=>{
        let durationArr = capData.duration.split(':')
        let durationCap = (Number(durationArr[0])*60)+Number(durationArr[1])
        totalDurationDay = Number(totalDurationDay) + durationCap
      })
 
      if(totalDurationDay > this.programDuration){
        this.exceedsProgramDuration = true
        // this.capsByDay[index].duration = this.previousDuration
        // return false
      }
      //---------------------------------------------
      const chapterSelected = this.capsByDay[index].chapter
      const arrNewValue = newValue.split(':')
      if(arrNewValue.length == 2){
        newValue = newValue + ":00"
        this.capsByDay[index].duration = newValue
      }

      let cutsDuration = ''
      let totalDuration = newValue
      // for(let i=0; i<index; i++){
      //   totalDuration = addTimes(totalDuration, this.capsByDay[i].duration)
      // }
      // VALIDACION PARA QUE LOS CORTES NO SOBREPASEN LA DURACION DEL MATERIAL
      const part1 = totalDuration.indexOf(':')
      const part2 = totalDuration.lastIndexOf(':')
      const horArtistic = totalDuration.substr(0, part1)
      const minArtistic = totalDuration.substr(part1 + 1, part2 - part1 - 1)
      const secArtistic = totalDuration.substr(part2 + 1)
      
      let cutsChap = JSON.parse(this.$localStorage.get('cutsOfChapter'))
      if(cutsChap.length > 0){
        let arrOfCutsToDelete = []
        // RECORRO LOS CORTES DEL CAP PARA SABER QUE CORTES EXCEDEN LA DURACION DEL CAP
        cutsChap.map((cut, i)=>{
          let timeInit = cut.start.split(':')
          let horInit = timeInit[0]
          let minInit = timeInit[1]
          // REDUZCO EL TIEMPO DE DURACION DEL MATERIAL Y ELIMINO LOS CORTES QUE EXCEDEN EL TIEMPO DE DURACION
          if(horInit>=horArtistic){
            if(horInit>horArtistic){
              arrOfCutsToDelete.push(i)
            } else if(horInit==horArtistic){
              if(minInit >= minArtistic){
                arrOfCutsToDelete.push(i)
              }
            }
          }
        })
        // ORDENO DE MAYOR A MENOR LOS INDEX PARA QUE AL ELIMINAR NO HAYA PROBLEMA DE RECORRER LOS CORTES
        arrOfCutsToDelete.sort((a,b)=>b-a)
        // ELIMINO LOS CORTES DEL CAP QUE EXCEDEN LA DURACION DEL CAP
       
        for(let x=0; x<arrOfCutsToDelete.length; x++){
          cutsChap.splice(arrOfCutsToDelete[x], 1)
        }
        
        // RECORRO LOS CORTES PARA OBTENER EL TOTAL DE LA DURACION DE LOS CORTES
        cutsChap.map((cut, i)=>{
          cutsDuration = addTimes(cutsDuration, cut.duration)
        })
      }
      
      // VUELVO A CALCULAR LA DURACION ARTISTICA
      this.capsByDay[index].cuts = cutsChap
      this.capsByDay[index].artisticDuration = restTimes(newValue, cutsDuration)
      const {chapters, dailyCuttingProgram} = this.cutsProgramInitialValue

      if(chapterSelected !== ''){
        if(dailyCuttingProgram[0].allChapters.cuts.length > 0){
          // ENTRA SI ACTUALMENTE CUENTA CON TODOS LOS CAPS
          let totalChapters = ''
          for (let i = 0; i < this.objFromGrid.cardsData.length; i++) {
            if(this.objFromGrid.cardsData[i].dailyProgramDate === this.oneDay.toString()){
              let isInclude = false
              this.objFromGrid.cardsData[i].chapters.map((chapterInfo)=>{
                if(chapterInfo.numChapter == chapterSelected){
                  isInclude = true
                }
              })
              if(isInclude){
                totalChapters = this.objFromGrid.cardsData[i].material.numChapters[0].chapters
                for(let c=0; c < totalChapters; c++){
                  let obj = ''
                  if((c+1) == chapterSelected){
                    obj = this.objToReturn(this.capsByDay[index].duration, this.capsByDay[index].artisticDuration, c+1, this.capsByDay[index].cuts)
                  } else {
                    obj = this.objToReturn(dailyCuttingProgram[0].artisticDuration, dailyCuttingProgram[0].allChapters.artisticDuration, c+1, dailyCuttingProgram[0].allChapters.cuts)
                  }
                  dailyCuttingProgram[0].individualChapters.push(obj)
                }
                dailyCuttingProgram[0].allChapters.cuts = []
              }
            }
          }
        } else if(dailyCuttingProgram[0].chapterRanges.length > 0 && dailyCuttingProgram[0].individualChapters.length > 0){
          // ENTRA SI CUENTA CON CORTES EN RANGOS Y EN CAPS INDIVIDUALES
          chapters.map((chapter)=>{
            if(chapterSelected == chapter.numChapter){
              let isChapterIncluded = false
              let obj
              dailyCuttingProgram[0].chapterRanges.map((chapterRange, x)=>{
                if((chapterRange.startChapter <= chapter.numChapter) && (chapterRange.finalChapter >= chapter.numChapter)){
                  isChapterIncluded = true
                  for(let i=chapterRange.startChapter; i<=chapterRange.finalChapter; i++){
                    if(String(i) == chapter.numChapter){
                      obj = {
                        applyAllIndiChapters: false,
                        duration: newValue,
                        artisticDuration: restTimes(newValue, cutsDuration),
                        chapter: String(i),
                        cuts: chapterRange.cuts
                      }
                    } else {
                      obj = {
                        applyAllIndiChapters: false,
                        duration: dailyCuttingProgram[0].artisticDuration,
                        artisticDuration: chapterRange.artisticDuration,
                        chapter: String(i),
                        cuts: chapterRange.cuts,
                      }
                    }
                    dailyCuttingProgram[0].individualChapters.push(obj)
                  }
                  dailyCuttingProgram[0].chapterRanges.splice(x, 1);
                }
              })

              dailyCuttingProgram[0].individualChapters.map((iChapter, index)=>{
                if((iChapter.chapter == chapter.numChapter)){
                  isChapterIncluded = true
                  dailyCuttingProgram[0].individualChapters[index].duration = newValue
                  dailyCuttingProgram[0].individualChapters[index].artisticDuration = restTimes(newValue, cutsDuration)
                }
              })

              if(isChapterIncluded == false){
                obj = {
                      applyAllIndiChapters: false,
                      duration: newValue,
                      artisticDuration: restTimes(newValue, cutsDuration),
                      chapter: String(chapter.numChapter),
                      cuts: this.capsByDay[index].cuts,
                    }
                dailyCuttingProgram[0].individualChapters.push(obj)
              }
            }
          })

        } else if(dailyCuttingProgram[0].chapterRanges.length > 0){
          // ENTRA SI CUENTA CON CORTES POR RANGO DE CAPS
          chapters.map((chapter)=>{
            if(chapterSelected == chapter.numChapter){
              let isWithinRange = false
              let obj
              dailyCuttingProgram[0].chapterRanges.map((chapterRange, x)=>{
                if((chapterRange.startChapter <= chapter.numChapter) && (chapterRange.finalChapter >= chapter.numChapter)){
                  isWithinRange = true
                  for(let i=chapterRange.startChapter; i<=chapterRange.finalChapter; i++){
                    if(String(i) == chapter.numChapter){
                      obj = {
                        applyAllIndiChapters: false,
                        duration: newValue,
                        artisticDuration: restTimes(newValue, cutsDuration),
                        chapter: String(i),
                        cuts: chapterRange.cuts,
                      }
                    } else {
                      obj = {
                        applyAllIndiChapters: false,
                        duration: dailyCuttingProgram[0].artisticDuration,
                        artisticDuration: chapterRange.artisticDuration,
                        chapter: String(i),
                        cuts: chapterRange.cuts,
                      }
                    }
                    dailyCuttingProgram[0].individualChapters.push(obj)
                  }
                  dailyCuttingProgram[0].chapterRanges.splice(x, 1);
                }
              })

              // SI EXISTEN RANGOS PERO EL CAP NO ESTA INCLUIDO EN LOS RANGOS EXISTENTES, SE CREA SU CORTE DENTRO DE INDIVIDUALES
              if(isWithinRange == false){
                obj = {
                      applyAllIndiChapters: false,
                      duration: newValue,
                      artisticDuration: restTimes(newValue, cutsDuration),
                      chapter: String(chapter.numChapter),
                      cuts: this.capsByDay[index].cuts,
                    }
                dailyCuttingProgram[0].individualChapters.push(obj)
              }
            }
          })
        } else if(dailyCuttingProgram[0].individualChapters.length > 0){
          // ENTRA SI CUENTA CON CORTES EN CAPITULOS INDIVIDUALES
          chapters.map((chapter)=>{
            if(chapterSelected == chapter.numChapter){
              let isIndividualChapter = false
              dailyCuttingProgram[0].individualChapters.map((iChapter, index)=>{
                if((iChapter.chapter == chapter.numChapter)){
                  isIndividualChapter = true
                  dailyCuttingProgram[0].individualChapters[index].duration = newValue
                  dailyCuttingProgram[0].individualChapters[index].artisticDuration = restTimes(newValue, cutsDuration)
                }
              })

              // SI EXISTEN CAPITULOS INDIVIDUALES PERO EL CAPITULO SELECCIONADO NO TIENE CORTES INDIVIDUALES
              if(isIndividualChapter == false){
                let obj = {
                      applyAllIndiChapters: false,
                      duration: newValue,
                      artisticDuration: restTimes(newValue, cutsDuration),
                      chapter: String(chapter.numChapter),
                      cuts: this.capsByDay[index].cuts
                    }
                dailyCuttingProgram[0].individualChapters.push(obj)
              }
            }
          })
        } 
      } else {
        dailyCuttingProgram[0].allChapters.duration = newValue
        dailyCuttingProgram[0].allChapters.artisticDuration = restTimes(newValue, cutsDuration)
      }
      // REEMPLAZA LOS CORTES PARA TODOS LOS 
      // this.replaceDataOfDays(dailyCuttingProgram)
      // QUITO EL FOCUS AL INPUT PARA QUE SE GUARDE EL VALOR ANTERIOR DE ESTE AL DARLE FOCO NUEVAMENTE
      let refEl = `duration-${index}`
      this.$refs[refEl][0].blur()
    },
    handleSelect () {
      
      // Mostrar información del día elegido
      this.capsByDay = []
      for (let i = 0; i < this.objFromGrid.cardsData.length; i++) {
        if (this.objFromGrid.cardsData[i].dailyProgramDate === this.oneDay.toString()) {
          // CALCULO DE LA DURACIÓN DEL PROGRAMA
          // this.objFromGrid.cardsData[i].isModification = true
          this.indexOfObjOfGrid = i
          this.$set(this.objFromGrid.cardsData[i], 'isModification', true)

          const {scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin} = this.objFromGrid.cardsData[i]
          const timeStart = Number(scheduleStartHour*60)+Number(scheduleStartMin)
          const timeEnd = Number(scheduleEndHour*60)+Number(scheduleEndMin)
          this.programDuration = timeEnd - timeStart
          // -----------------------
          let arrayCortes = this.objFromGrid.cardsData[i].dailyCuttingProgram[0]
          // MI VALOR INICIAL
          this.cutsProgramInitialValue = this.objFromGrid.cardsData[i]
          this.codeMaterialSelected = this.objFromGrid.cardsData[i].codMaterial

          const dataDay = this.objFromGrid.cardsData[i]
          const {chapters} = dataDay

          if(arrayCortes.allChapters.cuts.length > 0){
            console.log('entre aca 1')
            this.$localStorage.set('allChaptersCuts', JSON.stringify(arrayCortes.allChapters.cuts))
            chapters.map((chapter)=>{
              let chapterDuration = (arrayCortes.allChapters.duration)?arrayCortes.allChapters.duration:arrayCortes.artisticDuration
              /*Si no tiene  chapterDuration*/
              let newChapterDuration = chapterDuration == '' ? this.calculateDurationMaterial(this.objFromGrid.cardsData[i]) : chapterDuration
              chapterDuration = newChapterDuration
              this.showDataDay(this.capsByDay, chapterDuration, arrayCortes.allChapters.artisticDuration, chapter.numChapter, JSON.parse(this.$localStorage.get('allChaptersCuts')))
            })
          } else if(arrayCortes.chapterRanges.length > 0 && arrayCortes.individualChapters.length > 0){

            chapters.map((chapter, i)=>{
              arrayCortes.chapterRanges.map((chapterRange)=>{
                this.$localStorage.set('rangeChaptersCuts', JSON.stringify(chapterRange.cuts))
                if((chapterRange.startChapter <= chapter.numChapter) && (chapterRange.finalChapter >= chapter.numChapter)){
                  let objCap = this.objToReturn(arrayCortes.artisticDuration, chapterRange.artisticDuration, chapter.numChapter, JSON.parse(this.$localStorage.get('rangeChaptersCuts')))
                  this.capsByDay.push(objCap)
                }
              })
              const {material, numChapters} = this.objFromGrid.cardsData[i]
              const {codMaterial} = material
              let isMatOld = codMaterial.includes('M')
              if(isMatOld) {
                  arrayCortes.individualChapters.map((iChapter)=>{
                  if((iChapter.chapter == chapter.numChapter)){
                    let chapterDuration = (iChapter.duration)?iChapter.duration:arrayCortes.artisticDuration
                    let objCap = this.objToReturn(chapterDuration, iChapter.artisticDuration, chapter.numChapter, iChapter.cuts)
                    this.capsByDay.push(objCap)
                  }
                })
              }
            })
          } else if(arrayCortes.chapterRanges.length > 0){
            console.log('entre aca 3')
            chapters.map((chapter)=>{
              arrayCortes.chapterRanges.map((chapterRange)=>{
                this.$localStorage.set('rangeChaptersCuts', JSON.stringify(chapterRange.cuts))
                if((chapterRange.startChapter <= chapter.numChapter) && (chapterRange.finalChapter >= chapter.numChapter)){
                  this.showDataDay(this.capsByDay, arrayCortes.artisticDuration, chapterRange.artisticDuration, chapter.numChapter, JSON.parse(this.$localStorage.get('rangeChaptersCuts')))
                }
              })
            })
          } else if(arrayCortes.individualChapters.length > 0){
            // console.log(arrayCortes.individualChapters, 'arrayCortes.individualChapters 1111111')
            console.log('entre aca 4')
            const {material, scheduleEndHour, scheduleEndMin, scheduleStartHour, scheduleStartMin} = this.objFromGrid.cardsData[i]
            const {codMaterial, hoursMaterial, minutesMaterial, numChapters } = material
            let isMatOld = codMaterial.includes('M')
            if(!isMatOld) {
              // console.log(!isMatOld, 'entro')
              let data = arrayCortes.individualChapters.map((e) => {
                const {chapter, ...rest} = e
                return {
                  chapter: String(chapter),
                  ...rest
                }
              })
              // console.log(numChapters, 'numChapters')
              // console.log(arrayCortes.individualChapters, 'el.dailyCuttingProgram[0]')
              // console.log(data, 'data')
              let value
              if(numChapters.length > 0) {
                let allCuts = []
                this.objFromGrid.cardsData.map((el) => {
                  // console.log(el, 'el')
                  if(el.dailyCuttingProgram[0] && el.dailyCuttingProgram[0].individualChapters && el.dailyCuttingProgram[0].individualChapters.length > 0) {
                    allCuts.push(el.dailyCuttingProgram[0].individualChapters)
                  } else {
                    // console.log('grr')
                    if(el.dailyCuttingProgram[0]) {
                      allCuts.push(el.dailyCuttingProgram[0])
                    }
                  }
                })
                let allCutsProgram = [].concat.apply([], allCuts)
                // value = allCutsProgram
                value = this.getUnique(allCutsProgram, 'chapter')
              } else {
                value = this.getUnique(data, 'chapter')
              }
              
              arrayCortes.individualChapters = value
              
              // allCuts.push(this.objFromGrid.cardsData[i].dailyCuttingProgram[0].individualChapters)
              // console.log(allCuts, 'allCuts')
            }
            this.calculateDurationMaterial(this.objFromGrid.cardsData[i])
            // console.log(arrayCortes.individualChapters, 'arrayCortes.individualChapters')
            
              chapters.map((chapter)=>{
                arrayCortes.individualChapters.map((iChapter, i)=>{
                  if(iChapter.chapter == chapter.numChapter){
                    let chapterDuration = (iChapter.duration)?iChapter.duration:arrayCortes.artisticDuration

                    /*Si no tiene  chapterDuration*/
                    let newChapterDuration = chapterDuration == '' ? this.calculateDurationMaterial(this.objFromGrid.cardsData[0]) : chapterDuration
                    chapterDuration = newChapterDuration
                    console.log(iChapter.cuts, 'iChapter.cuts')
                    this.showDataDay(this.capsByDay, chapterDuration, iChapter.artisticDuration, chapter.numChapter, iChapter.cuts)
                  } else if(!isMatOld && chapter.numChapter === ''){
                    // console.log(chapter, 'no tiene chapter')
                    let chapterDuration = (iChapter.duration)?iChapter.duration:arrayCortes.artisticDuration
                    let newChapterDuration = chapterDuration == '' ? this.calculateDurationMaterial(this.objFromGrid.cardsData[i]) : chapterDuration
                    chapterDuration = newChapterDuration
                    // let conditionalMat = this.calculateDurationMaterial(this.objFromGrid.cardsData[i])
                    // let chapterDuration = conditionalMat
                    // console.log(iChapter.artisticDuration, 'iChapter.artisticDuration')
                    // console.log(iChapter, 'iChapter')
                    // console.log(timeProgram, 'timeProgram')
                    // console.log(timeMaterial, 'timeMaterial')
                    // let chapterDuration = (iChapter.duration)?iChapter.duration:arrayCortes.artisticDuration
                    let conditional = iChapter.artisticDuration >= chapterDuration ? chapterDuration : iChapter.artisticDuration
                    this.showDataDay(this.capsByDay, chapterDuration, conditional, chapter.numChapter, iChapter.cuts)
                  }
                })
              })
          }

          let capsId = []
          this.capsByDay.map((cap)=>{
            capsId.push(cap.chapter)
          })

          if(this.capsByDay.length < chapters.length){
            chapters.map((chapter)=>{
              if(!(capsId.includes(chapter.numChapter))){
                let objCap = {
                  chapter: chapter.numChapter,
                  duration: (chapter.duration)?chapter.duration:arrayCortes.artisticDuration,
                  artisticDuration: arrayCortes.artisticDuration,
                  cuts: '',
                  numberOfCuts: ''
                }
                this.capsByDay.push(objCap)
              }
            })
          }
        }
      }
    },
    calculateDurationMaterial(value) {
      // console.log(value, 'value')
      const {material, numChapters, scheduleEndHour, scheduleEndMin, scheduleStartHour, scheduleStartMin} = value
      const {codMaterial, hoursMaterial, minutesMaterial } = material
      // console.log(material, 'material')
      let timeProgram = this.calculateTimeOfProgram(`${scheduleEndHour}:${scheduleEndMin}:00`, `${scheduleStartHour}:${scheduleStartMin}:00`) 
      let timeMaterial = `${hoursMaterial}:${minutesMaterial}:00`
      let conditionalMat = this.decideHourChoose(timeMaterial, timeProgram)
      return conditionalMat
    },
    calculateTimeOfProgram(finalHour, startHour) {
      let hourdEnd = finalHour === '00:00:00' ? '24:00:00' : finalHour
      if(hourdEnd > startHour) {
        let value = restTimes(finalHour, startHour) 
        return value 
      } else {
        let value = this.restHourInNigth(hourdEnd, startHour)
        return value
      }
    },
    restHourInNigth(hourdEnd, startHour) {
      let evaluated = hourdEnd.split(':')
      let choose = evaluated[0]
      let hour
      if(choose === '00') {
        evaluated[0] = '24'
        hour = evaluated.join(':')
      } else {
        hour = evaluated.join(':')
      }
      return restTimes(hour, startHour)
      
    },
    decideHourChoose(timeMaterial, timeProgram) {
      let valueReturn
      if(timeMaterial >= timeProgram) {
        valueReturn = timeProgram
      } else {
        valueReturn = timeProgram
      }
      return valueReturn
    },
    makeCuts (timeOfCut, numberOfCuts, artisticDuration, index, matDuration) {
      if(Number(timeOfCut) > 59) {
        timeOfCut = ''
        this.capsByDay[index].timeOfCut = timeOfCut
      } 
      const chapterSelected = this.capsByDay[index].chapter
      if (numberOfCuts !== '' && timeOfCut !== '') {
        this.arrCuts = []
        var numberCuts = numberOfCuts
        var timeCut = timeOfCut
        var durationTotal = ''
        for (let i = 0; i < numberCuts; i++) {
          // Tiempo inicio de corte
          if (i == 0) {
            let arrTimeSec = matDuration.split(':')
            let sumTimeSec = (Number(arrTimeSec[0]*60) *60) + Number(arrTimeSec[1]*60)
            let second = '00'
            let hour = '00'
            let minute = '00'
            let cutTime = ''
            
            if(sumTimeSec<900){
              // SI LA DURACION ES MENOR A 15MIN
              minute = Math.floor((sumTimeSec / 2)/60)
              if(minute<10){
                minute = '0' + minute 
              }
              cutTime = hour + ':' + minute + ':' + second
            } else {
              cutTime = '00:10:00'
            }

            var tci = cutTime
            // if(index > 0){
            //   let prevDuration = this.capsByDay[index-1].duration.split(':')
            //   let cutTimeFormat = cutTime.split(':')
            //   let hourSum = Number(prevDuration[0]) + Number(cutTimeFormat[0])
            //   let hourFinal = (hourSum<10)?'0'+hourSum:hourSum
            //   let minSum = Number(prevDuration[1]) + Number(cutTimeFormat[1])
            //   let minFinal = (minSum<10)?'0'+minSum:minSum
            //   let secSum = Number(prevDuration[2]) + Number(cutTimeFormat[2])
            //   let secFinal = (secSum<10)?'0'+secSum:secSum
            //   tci = hourFinal + ':' + minFinal + ':' + secFinal
            // } else {
            //   tci = cutTime
            // }
          } else {
            let timeInit = Number(i*10) + 20
            let timeInitSec = (Number(timeInit) * 60)
            var horInit = Math.floor(timeInitSec / 3600)
            if(horInit < 10){
              horInit = '0'+ String(horInit)
            }
            var minInit = Math.floor((timeInitSec - (horInit * 3600)) / 60)
            if(minInit < 10){
              minInit = '0'+ String(minInit)
            }
            var secInit = timeInitSec - (horInit * 3600) - (minInit * 60)
            if(secInit < 10){
              secInit = '0'+ String(secInit)
            }

            var tci = horInit + ':' + minInit + ':' + secInit
            const previousCut = this.arrCuts[this.arrCuts.length - 1]
            // VALIDAR QUE EL TIEMPO DE INICIO DEL CORTE ACTUAL NO SEA MENOR AL TIEMPO DE CORTE FINAL
            if(previousCut.end >= tci){
              this.saveNewData(chapterSelected, artisticDuration, this.arrCuts)
              this.capsByDay[index].numberOfCuts = ''
              this.capsByDay[index].timeOfCut = ''
              this.validateCutInit(i)
              return false
            }
          }

          // VALIDACION PARA QUE LOS CORTES NO SOBREPASEN LA DURACION DEL MATERIAL
          var sep1 = matDuration.indexOf(':')
          var sep2 = matDuration.lastIndexOf(':')
          var horArtistic = matDuration.substr(0, sep1)
          var minArtistic = matDuration.substr(sep1 + 1, sep2 - sep1 - 1)
          var secArtistic = matDuration.substr(sep2 + 1)
          
          if(horInit>=horArtistic){
            if(horInit>horArtistic){
              // GUARDAR LA DATA
              this.saveNewData(chapterSelected, artisticDuration, this.arrCuts)
              this.capsByDay[index].numberOfCuts = ''
              this.capsByDay[index].timeOfCut = ''
              // MUESTRA MODAL CORTES EXCEDEN DURACION 
              this.validateCuts()
              return false
            } else if(horInit==horArtistic){
              if(minInit > minArtistic){
                // GUARDAR LA DATA
                this.saveNewData(chapterSelected, artisticDuration, this.arrCuts)
                this.capsByDay[index].numberOfCuts = ''
                this.capsByDay[index].timeOfCut = ''
                // MUESTRA MODAL CORTES EXCEDEN DURACION
                this.validateCuts()
                return false
              }
            }
          }

          // Duración de corte
          timeCut = timeCut.length === 1 ? '0' + timeCut : timeCut
          var duration = '00:' + timeCut + ':00'
          durationTotal = addTimes(durationTotal, duration)

          // Restar tiempo a Duración artística
          artisticDuration = restTimes(artisticDuration, durationTotal)
          // Tiempo fin de corte
          var tcf = addTimes(tci, duration)

          // REEMPLAZA LOS CORTES CREADOS
          // VALIDA SI EL TIEMPO DE CORTE FINAL NO EXCEDE LA DURACION DEL CAPITULO
          let totalDuration = matDuration
          // for(let i=0; i<index; i++){
          //   totalDuration = addTimes(totalDuration, this.capsByDay[i].duration)
          // }

          if(tcf > totalDuration){
            this.validateCuts()
            return false
          } else {
            let newCutObj = {'id': i+1, 'start': tci, 'duration': duration, 'end': tcf}         
            this.arrCuts.push(newCutObj)
            this.capsByDay[index].cuts = this.arrCuts
        
            // REEMPLAZA DURACION ARTISTICA
            artisticDuration = restTimes(matDuration, durationTotal)
            this.capsByDay[index].artisticDuration = artisticDuration
          }
        }

        // METODO QUE ACTUALIZA LA DATA QUE SE VA A GUARDAR EN LA BD
        this.saveNewData(chapterSelected, artisticDuration, this.arrCuts)
        this.capsByDay[index].numberOfCuts = ''
        this.capsByDay[index].timeOfCut = ''
      } 
    },
    // METODOS PARA MOSTRAR DATA DEL DIA SELECCIONADO
    showDataDay(arr, duration, artisticDuration, chapter, cuts) {
      let objCap = this.objToReturn(duration, artisticDuration, chapter, cuts)
      arr.push(objCap)
    },
    // METODOS PARA GUARDAR LA NUEVA DATA AL EDITAR CORTES
    saveNewData (chapterSelected, artisticDuration, arrCuts){
      //GENERO NUEVAMENTE LOS CORTES PARA LA SEMANA
      const {chapters, dailyCuttingProgram} = this.cutsProgramInitialValue

      if(chapterSelected !== ''){
        if(dailyCuttingProgram[0].allChapters.cuts.length > 0){
          // ENTRA SI ACTUALMENTE CUENTA CON TODOS LOS CAPS
          let totalChapters = ''
          for (let i = 0; i < this.objFromGrid.cardsData.length; i++) {
            if(this.objFromGrid.cardsData[i].dailyProgramDate === this.oneDay.toString()){
              let isInclude = false
              this.objFromGrid.cardsData[i].chapters.map((chapterInfo)=>{
                if(chapterInfo.numChapter == chapterSelected){
                  isInclude = true
                }
              })
              
              if(isInclude){
                totalChapters = this.objFromGrid.cardsData[i].material.numChapters[0].chapters
                // console.log(totalChapters, 'totalChapters')
                for(let c=0; c < totalChapters; c++){
                  let obj = ''
                  if((c+1) == chapterSelected){
                    obj = this.objToReturn(dailyCuttingProgram[0].artisticDuration, artisticDuration, c+1, arrCuts)
                  } else {
                    obj = this.objToReturn(dailyCuttingProgram[0].artisticDuration, dailyCuttingProgram[0].allChapters.artisticDuration, c+1, dailyCuttingProgram[0].allChapters.cuts)
                  }
                    dailyCuttingProgram[0].individualChapters.push(obj)
                }
                dailyCuttingProgram[0].allChapters.cuts = []
                /*Sacar elementos repetidos de un array de obj */
                // console.log(dailyCuttingProgram[0].individualChapters, 'dailyCuttingProgram[0].individualChapters')
                // const {material, numChapters} = this.objFromGrid.cardsData[i]
                // const {codMaterial} = material
                // let isMatOld = codMaterial.includes('M')
                // if(!isMatOld) {
                //   dailyCuttingProgram[0].individualChapters = this.getUnique(dailyCuttingProgram[0].individualChapters)
                // }
                
              }
            }
          }
        } else if(dailyCuttingProgram[0].chapterRanges.length > 0 && dailyCuttingProgram[0].individualChapters.length > 0){
          // ENTRA SI CUENTA CON CORTES EN RANGOS Y EN CAPS INDIVIDUALES
          chapters.map((chapter)=>{
            if(chapterSelected == chapter.numChapter){
              let isTrue = false

              // ITERA LOS RANGOS
              const finalData = this.iterateChapterRange(isTrue, dailyCuttingProgram[0], chapter, artisticDuration, arrCuts)
              dailyCuttingProgram[0] = finalData.dailyCuttingProgram
              isTrue = finalData.isTrue
              // ITERA LOS CAPS INDIVIDUALES
              const data = this.iterateIndividualChapter(isTrue, dailyCuttingProgram[0], chapter, artisticDuration, arrCuts)
              dailyCuttingProgram[0] = data.dailyCuttingProgram
              isTrue = data.isTrue

              dailyCuttingProgram[0] = this.chapterIsNotIncluded(isTrue, dailyCuttingProgram[0], artisticDuration, chapter, arrCuts)
            }
          })

        } else if(dailyCuttingProgram[0].chapterRanges.length > 0){
          // ENTRA SI CUENTA CON CORTES POR RANGO DE CAPS
          chapters.map((chapter)=>{
            if(chapterSelected == chapter.numChapter){
              let isTrue = false
              const finalData = this.iterateChapterRange(isTrue, dailyCuttingProgram[0], chapter, artisticDuration, arrCuts)
              dailyCuttingProgram[0] = finalData.dailyCuttingProgram
              isTrue = finalData.isTrue
              
              // SI EXISTEN RANGOS PERO EL CAP NO ESTA INCLUIDO EN LOS RANGOS EXISTENTES, SE CREA SU CORTE DENTRO DE INDIVIDUALES
              dailyCuttingProgram[0] = this.chapterIsNotIncluded(isTrue, dailyCuttingProgram[0], artisticDuration, chapter, arrCuts)         
            }
          })
        } else if(dailyCuttingProgram[0].individualChapters.length > 0){
          // ENTRA SI CUENTA CON CORTES EN CAPITULOS INDIVIDUALES
          chapters.map((chapter, i)=>{
          //   this.objFromGrid.cardsData.map((mat, i) => {
          //   console.log(this.objFromGrid.cardsData, 'this.objFromGrid.cardsData[0]')
          //   const {material, numChapters} = this.objFromGrid.cardsData[i]
          //   const {codMaterial} = material
          //   console.log(this.objFromGrid.cardsData[i], 'this.objFromGrid.cardsData[0]')
          //   console.log(codMaterial, 'codMaterial')
          //   // console.log(isMatOld, 'isMatOld')
          //   // let isMatOld = codMaterial.includes('M')
            
          //   if(codMaterial && !codMaterial.includes('M')) {
          //     dailyCuttingProgram[0].individualChapters = this.getUnique(dailyCuttingProgram[0].individualChapters)
          //   }
          // })
            let chapterIterate = chapter.numChapter
            if(chapterIterate == '' && chapter.rolCodigoSelected){
              chapterIterate = 1
            }
            
            if(chapterSelected == chapterIterate){
              let isTrue = false
              const finalData = this.iterateIndividualChapter(isTrue, dailyCuttingProgram[0], chapter, artisticDuration, arrCuts)
              dailyCuttingProgram[0] = finalData.dailyCuttingProgram
              isTrue = finalData.isTrue
              // SI EXISTEN CAPITULOS INDIVIDUALES PERO EL CAPITULO SELECCIONADO NO TIENE CORTES INDIVIDUALES
            }
          })
        } else {
          // ENTRA SI NO TIENE CORTES
          chapters.map((chapter)=>{
            if(chapterSelected == chapter.numChapter){
              // SE CORTE INDIVIDUAL
              dailyCuttingProgram[0] = this.chapterIsNotIncluded(false, dailyCuttingProgram[0], artisticDuration, chapter, arrCuts)
            }
          })
        }
      } else {
        dailyCuttingProgram[0].allChapters.duration = (dailyCuttingProgram[0].allChapters.duration)?dailyCuttingProgram[0].allChapters.duration:dailyCuttingProgram[0].artisticDuration
        dailyCuttingProgram[0].allChapters.artisticDuration = artisticDuration
        dailyCuttingProgram[0].allChapters.cuts = arrCuts
      }

      // REEMPLAZA LOS CORTES PARA TODOS LOS DIAS
      this.replaceDataOfDays(dailyCuttingProgram)
    },
    getUnique(arr, comp) {
      const unique = arr.map(e => e[comp])

        // store the keys of the unique objects
        .map((e, i, final) => final.indexOf(e) === i && i)

        // eliminate the dead keys & store unique objects
        .filter(e => arr[e]).map(e => arr[e]);

      return unique;
    },
    chapterIsNotIncluded (isTrue, dailyCuttingProgram, artisticDuration, chapter, arrCuts){
      if(!isTrue){
        let obj = this.objToReturn(dailyCuttingProgram.artisticDuration, artisticDuration, chapter.numChapter, arrCuts)
        dailyCuttingProgram.individualChapters.push(obj)
      }
      return dailyCuttingProgram
    },
    iterateIndividualChapter (isTrue, dailyCuttingProgram, chapter, artisticDuration, arrCuts){
      let chapterIterate = chapter.numChapter
      if(chapterIterate == '' && chapter.rolCodigoSelected){
        chapterIterate = 1
      }
      dailyCuttingProgram.individualChapters.map((iChapter, index)=>{
        if((iChapter.chapter == chapterIterate)){
          isTrue = true
          dailyCuttingProgram.individualChapters[index].duration = (dailyCuttingProgram.individualChapters[index].duration)?dailyCuttingProgram.individualChapters[index].duration: dailyCuttingProgram.artisticDuration
          dailyCuttingProgram.individualChapters[index].artisticDuration = artisticDuration
          dailyCuttingProgram.individualChapters[index].cuts = arrCuts
        }
      })
      
      return {dailyCuttingProgram, isTrue}
    },
    iterateChapterRange (isTrue, dailyCuttingProgram, chapter, artisticDuration, arrCuts){
      let obj = ''
      
      dailyCuttingProgram.chapterRanges.map((chapterRange, x)=>{
        if((chapterRange.startChapter <= chapter.numChapter) && (chapterRange.finalChapter >= chapter.numChapter)){
          isTrue = true
          for(let i=chapterRange.startChapter; i<=chapterRange.finalChapter; i++){
            if(String(i) == chapter.numChapter){
              obj = this.objToReturn(dailyCuttingProgram.artisticDuration, artisticDuration, i, arrCuts)
            } else {
              obj = this.objToReturn(dailyCuttingProgram.artisticDuration, chapterRange.artisticDuration, i, chapterRange.cuts)
            }
            dailyCuttingProgram.individualChapters.push(obj)
          }
          dailyCuttingProgram.chapterRanges.splice(x, 1);
        }
      })
      
      return {dailyCuttingProgram, isTrue}
    },
    objToReturn (duration, artisticDuration, chapter, cuts){
      let obj = {
                  applyAllIndiChapters: false,
                  duration: duration,
                  artisticDuration: artisticDuration,
                  chapter: String(chapter),
                  cuts: cuts
                }

      return obj
    },
    replaceDataOfDays(dailyCuttingProgram){
      // REEMPLAZA LOS CORTES PARA TODOS LOS DIAS
      for (let i = 0; i < this.objFromGrid.cardsData.length; i++) {
        if(this.codeMaterialSelected == this.objFromGrid.cardsData[i].codMaterial){
          let objSelected = this.objFromGrid.cardsData[i]
          if((objSelected.chapters.length == 1) && (objSelected.chapters[0].numChapter == '')){
            if(this.indexOfObjOfGrid == i){
              this.objFromGrid.cardsData[i].dailyCuttingProgram = dailyCuttingProgram
            }
          } else {
            this.objFromGrid.cardsData[i].dailyCuttingProgram = dailyCuttingProgram
          }
        }
      }
      console.log(this.objFromGrid.cardsData, 'this.objFromGrid.cardsData')
    },
    // END
    calculateTimeEnd (index, indice, cuts, matDuration) {
      if(cuts[index] !== undefined){
        const {start: startDate, duration: durationDate, end: endDate} =  cuts[index]
        let start = startDate
        let duration = durationDate
        let end = endDate
        var newDurationTotal = ''
        
        if (start.indexOf(':') === 2 && start.lastIndexOf(':') === 2) {
          start = cuts[index].start + ':00'
        }
        
        if (duration.indexOf(':') === 2 && duration.lastIndexOf(':') === 2) {
          duration = cuts[index].duration + ':00'
        }

        // SOLO ENTRA A VALIDAR SI EL CORTE SELECCIONADO NO ES EL 1ER CORTE
        if(index>0){
          const previousCut = cuts[index-1]
          const cutSelect = cuts[index]
          // VALIDAR QUE EL TIEMPO DE INICIO DEL CORTE ACTUAL NO SEA MENOR AL TIEMPO DE CORTE FINAL
          if(previousCut.end >= cutSelect.start){
            this.capsByDay[indice].cuts.splice(index, 1)
            this.saveNewData(chapterSelect, this.capsByDay[indice].artisticDuration, cuts)
            this.validateCutInit(index)
            return false
          }
        }
        
        let totalDuration = matDuration
        // for(let i=0; i<indice; i++){
        //   totalDuration = addTimes(totalDuration, this.capsByDay[i].duration)
        // }

        const timeInit = start.split(':')
        const horInit = timeInit[0]
        const minInit = timeInit[1]
        let sep1 = totalDuration.indexOf(':')
        let sep2 = totalDuration.lastIndexOf(':')
        let horArtistic = totalDuration.substr(0, sep1)
        let minArtistic = totalDuration.substr(sep1 + 1, sep2 - sep1 - 1)
        let secArtistic = totalDuration.substr(sep2 + 1)
        
        if(horInit>=horArtistic){
          if(horInit>horArtistic){
            // MUESTRA MODAL CORTES EXCEDEN DURACION 
            this.validateCuts()
            // COMO NO SE VA A GUARDAR EN LA DATA EL CORTE EXCEDENTE, DEBERIA BORRARLO AUTOMATICAMENTE
            this.capsByDay[indice].cuts.splice(index, 1)
            return false
          } else if(horInit==horArtistic){
            if(minInit >= minArtistic){
              // MUESTRA MODAL CORTES EXCEDEN DURACION
              this.validateCuts()
              // COMO NO SE VA A GUARDAR EN LA DATA EL CORTE EXCEDENTE, DEBERIA BORRARLO AUTOMATICAMENTE
              this.capsByDay[indice].cuts.splice(index, 1)
              return false
            }
          }
        }
        // CALCULA LA DURACION FINAL DEL CORTE
        end = addTimes(start, duration)
        // VALIDA SI EL TIEMPO DE CORTE FINAL NO EXCEDE LA DURACION DEL CAPITULO
        if(end > totalDuration){
          this.validateCuts()
          this.capsByDay[indice].cuts.splice(index, 1)
        } else {
          // ACTUALIZA EL CORTE YA CON SU DURACION FINAL
          cuts.splice(index, 1, {'id': index+1, 'start': start, 'duration': duration, 'end': end})
        }

        for (var i = 0; i < cuts.length; i++) {
          newDurationTotal = addTimes(newDurationTotal, cuts[i].duration)
        }

        //REEMPLAZADO VALORES A MOSTRAR
        this.capsByDay[indice].artisticDuration = restTimes(matDuration, newDurationTotal)
        this.capsByDay[indice].cuts = cuts

        // GENERO NUEVAMENTE LOS CORTES PARA LA SEMANA
        const chapterSelect = this.capsByDay[indice].chapter

        // METODO QUE ACTUALIZA LA DATA QUE SE VA A GUARDAR EN LA BD
        let artisticDurationUpdated = this.capsByDay[indice].artisticDuration
        this.saveNewData(chapterSelect, artisticDurationUpdated, cuts)
      }
    },
    removeCut (index, cuts, indiceChapter) {
      this.arrCuts = []
      if(cuts.length > 0){
        cuts.map((cut)=>{
          this.arrCuts.push(cut)
        })
      }

      let initialDuration = this.capsByDay[indiceChapter].artisticDuration
      let durationToSum = this.arrCuts[index].duration
      //ACA ELIMINO EL CORTE SELECCIONADO
      this.arrCuts.splice(index, 1)

      // MODIFICO EL ID DE LOS CORTES
      for(let i=0; i<this.arrCuts.length; i++){
        this.arrCuts[i].id = i+1
      }

      // this.capsByDay[indiceChapter].numberOfCuts--
      this.capsByDay[indiceChapter].cuts = this.arrCuts
      this.capsByDay[indiceChapter].artisticDuration = addTimes(initialDuration, durationToSum)

      // GENERO NUEVAMENTE LOS CORTES PARA LA SEMANA
      let chapterSelect = this.capsByDay[indiceChapter].chapter

      if((this.objFromGrid.cardsData.length > 1) && (chapterSelect == '')){
        for(let x=0; x<this.objFromGrid.cardsData.length; x++){
          if(x == this.indexOfObjOfGrid && this.objFromGrid.cardsData[x].chapters[0].rolCodigoSelected){
            chapterSelect = 1
          }
        }
      }
      
      // METODO QUE ACTUALIZA LA DATA QUE SE VA A GUARDAR EN LA BD
      let artisticDurationUpdated = this.capsByDay[indiceChapter].artisticDuration
      this.saveNewData(chapterSelect, artisticDurationUpdated, this.arrCuts)
    },
    addCuts (index, cuts, indiceChapter) {
      //DEBO HACERLO DE ESTA MANERA DEBIDO A QUE EL CORTE NUEVO SE ESTABA AGREGANDO A MI RANGO INICIAL
      this.arrCuts = [] 

      if(cuts.length > 0){
        cuts.map((cut)=>{
          this.arrCuts.push(cut)
        })
      }

      this.arrCuts.map((el, i, arr) => {
        if (i == index) {
          let obj = {'id': i+2, 'start': '00:00:00', 'duration': '00:00:00', 'end': '00:00:00'}
          this.arrCuts.splice(i + 1, 0, obj);
        }
      });

      // MODIFICO EL ID DE LOS CORTES
      for(let i=0; i<this.arrCuts.length; i++){
        this.arrCuts[i].id = i+1
      }

      //REEMPLAZADO VALORES A MOSTRAR
      // this.capsByDay[indiceChapter].numberOfCuts++
      this.capsByDay[indiceChapter].cuts = this.arrCuts

    },
    sendEditCuts (programObj) {
      this.alertPrevToSave = true
      this.$localStorage.set('programedProgram', JSON.stringify(programObj))
      // if (programObj.grid.weekDate !== 'Week not found') {
      const channel = this.$localStorage.get('channelTransmition')
      let programs = programObj.grid.fullGrid.programs;
      let cleanPrograms = [];

      cleanPrograms = programs.filter(function(item) { 
        item.isModification = false
        return item.programGridTitle !== programObj.programInfo.programTitle;
      })
      // FILTRO SOLO LOS DIAS QUE CONTIENEN INFO


      let programsNoEmpty = this.objFromGrid.cardsData.filter((item)=>{
        return item.codMaterial !== ''
      })

      let allPrograms = programsNoEmpty.concat(cleanPrograms)
      
      let daysWithoutClosure = []
      // VERIFICA SI ALGUNO DE LOS DIAS DE TRANSMISION CONTIENE CIERRE
      let finalDaysWithClosure = this.daysWithClosureOrcl

      if(finalDaysWithClosure.length > 0){
        // RECORRO LOS DIAS DE TRANSMISION DEL PROGRAM, Y OBTENGO LOS DIAS QUE NO TIENEN CIERRE DE GUIA
        this.daysOfProgram.map((dayOfTransmission) => {
          if(!(finalDaysWithClosure.includes(dayOfTransmission))){
            daysWithoutClosure.push(dayOfTransmission)
          }
        })
        // VERIFICO SI HAY DIAS QUE NO TIENEN CIERRE DE GUIA
        if(daysWithoutClosure.length > 0){
          let arrDataOfDaysWithoutClosure = []
          // VERIFICO A QUE DIAS QUE NO TIENEN CIERRE DE GUIA SE LES HA LLENADO DATA
          programsNoEmpty.map((byDay)=>{
            if(daysWithoutClosure.includes(byDay.completeDate)){
              byDay.userName = localStorage.getItem('userName');
              arrDataOfDaysWithoutClosure.push(byDay)
            }
          })
          // SI HAY DIAS CON DATA Y NO TIENEN CIERRE DE GUIA
          if(arrDataOfDaysWithoutClosure.length > 0){
            // ACA HACER UPDATE EN ORACLE
            HTTP.patch(`grid/updateOrcl/${programObj.grid._id}`,
              [
                { propName: "programs", value: arrDataOfDaysWithoutClosure},
                { propName: "crushedPrograms", value: [] }
              ]
            )
            .then(res=>{
              console.log('termineee')
               setTimeout(() => {
                this.alertPrevToSave = false
                this.modalUpdateToGoBack = true
                this.getDataGrid()
                }
              , 10000)
            })
            .catch(err=> console.log(err, 'err'))
          }
        }

        // UPDATE EN MONGODB
        HTTP.patch(`grid/update/${programObj.grid._id}`,
          [
            { propName: "programs", value: allPrograms }
          ]
        ).then(res=>{
          // let channelTransmission = channel
          // this.$router.replace({name: 'gridContent', params: {type: channelTransmission}})
          setTimeout(() => {
            this.alertPrevToSave = false
            this.modalUpdateToGoBack = true
            this.getDataGrid()
            }
          , 10000)
        })
        .catch(err => console.log(err))

      } else {
        
        HTTP.patch('grid/' + programObj.grid._id,
        [
          { propName: "programs", value: allPrograms }
        ])
        .then(res => {
          // this.$router.replace({name: 'gridContent', params: {type: this.typeChannel}})
          setTimeout(() => {
            this.alertPrevToSave = false
            this.modalUpdateToGoBack = true
            this.getDataGrid()
            }
          , 10000)
        })
        .catch(err => console.log(err));
      }
    },
    getDataGrid() {
      let value = ["grid"]
      value.map((e) => {
        this.$store.dispatch('getData', e)
      })
    },
    validateCuts(){
      this.textShow = '<strong>Los cortes exceden la duración del material.</strong>'
      this.messageExist = true
    },
    validateCutInit(i){
      this.textShow = `<strong>El tiempo de fin del corte ${i} es mayor al tiempo de inicio del corte ${i+1}.</strong>`
      this.messageExist = true
    },
    getDaysWithClosureOcl(daysOfProgram) {
      const channel = this.$localStorage.get('channelTransmition')
      //OBTENGO LOS DIAS QUE TIENEN CIERRE EN GEMINIS
      daysOfProgram.map((day) => {
        HTTP.get(`guideClosure/byTransmissionDay/${day}/${channel}`)
        .then(res => {
          const {daySelected, isClosed} = res.data
          if(isClosed == true){
            this.daysWithClosureOrcl.push(daySelected)
          }
        })
      })
    },
    validateDurationProgram(objFromGrid) {
      const transmissionDays = objFromGrid.cardsData
      // FILTRO SOLO LOS DIAS QUE CONTIENEN INFO
      const daysWithProgramming = transmissionDays.filter((item)=>{
        return item.codMaterial !== ''
      })
      
      let chaptersWithoutCuts = []
      let daysWithoutCuts = []
      let exceedDuration = []
      daysWithProgramming.map((day)=>{
        // OBTENIENDO DURACION DEL PROGRAMA
        const programDuration = this.gettingDuration(day)
        let daySelected = day.completeDate.split(' ')[0]
        let totalDurationDay = '00:00:00'
        day.chapters.map((chapter)=>{
          const objOfCuts = day.dailyCuttingProgram[0]
          if(objOfCuts.allChapters.cuts.length > 0){
            // SI TIENE CORTES EN TODOS LOS CAPITULOS
            const chapterDuration = (objOfCuts.allChapters.duration)?objOfCuts.allChapters.duration:objOfCuts.artisticDuration
            totalDurationDay = addTimes(chapterDuration, totalDurationDay)
          } else if(objOfCuts.chapterRanges.length > 0 && objOfCuts.individualChapters.length > 0){
            let isIncludeChapter = false
            // SI TIENE CORTES EN RANGOS E INDIVIDUALES
            objOfCuts.chapterRanges.map((chapterRange, index)=>{
              if((chapterRange.startChapter <= chapter.numChapter) && (chapterRange.finalChapter >= chapter.numChapter)){
                for(let i=chapterRange.startChapter; i<=chapterRange.finalChapter; i++){
                  if(String(i) == chapter.numChapter){
                    isIncludeChapter = true
                    const chapterDuration = this.getTotalDuration(chapterRange.cuts, chapterRange.artisticDuration)
                    totalDurationDay = addTimes(chapterDuration, totalDurationDay)
                  }
                }
              }
            })
            // SI TIENE CORTE EN INDIVIDUALES
            objOfCuts.individualChapters.map((iChapter, index)=>{
              if((iChapter.chapter == chapter.numChapter && iChapter.cuts.length > 0)){
                isIncludeChapter = true
                const chapterDuration = this.getTotalDuration(iChapter.cuts, iChapter.artisticDuration)
                totalDurationDay = addTimes(chapterDuration, totalDurationDay)
              }
            })

            if(isIncludeChapter == false){
              if(!daysWithoutCuts.includes(day.completeDate)){
                daysWithoutCuts.push(day.completeDate)
              }
              // chaptersWithoutCuts.push(chapter.numChapter)
            }
          } else if(objOfCuts.chapterRanges.length > 0){
            // SI TIENE CORTE EN RANGOS
            let isIncludeChapter = false
            objOfCuts.chapterRanges.map((chapterRange, index)=>{
              if((chapterRange.startChapter <= chapter.numChapter) && (chapterRange.finalChapter >= chapter.numChapter)){
                for(let i=chapterRange.startChapter; i<=chapterRange.finalChapter; i++){
                  if(String(i) == chapter.numChapter){
                    isIncludeChapter = true
                    const chapterDuration = this.getTotalDuration(chapterRange.cuts, chapterRange.artisticDuration)
                    totalDurationDay = addTimes(chapterDuration, totalDurationDay)
                  }
                }
              }
            })

            if(isIncludeChapter == false){
              if(!daysWithoutCuts.includes(day.completeDate)){
                daysWithoutCuts.push(day.completeDate)
              }
              // chaptersWithoutCuts.push(chapter.numChapter)
            }
          } else if(objOfCuts.individualChapters.length > 0){
            // SI TIENE CORTE EN INDIVIDUALES
            let isIncludeChapter = false
            let chapterSelect = chapter.numChapter
            // SI ES UN MATERIAL SIN CAPITULOS PERO SE TRANSMITE VARIOS DIAS A LA SEMANA
            if(chapter.rolCodigoSelected && (chapterSelect == '')){
              chapterSelect = 1
            }
            objOfCuts.individualChapters.map((iChapter, index)=>{
              if((iChapter.chapter == chapterSelect && iChapter.cuts.length > 0)){
                isIncludeChapter = true
                const chapterDuration = this.getTotalDuration(iChapter.cuts, iChapter.artisticDuration)
                totalDurationDay = addTimes(chapterDuration, totalDurationDay)
              }
            })
            
            if(isIncludeChapter == false){
              // chaptersWithoutCuts.push(chapter.numChapter)
              if(!daysWithoutCuts.includes(day.completeDate)){
                daysWithoutCuts.push(day.completeDate)
              }
            }
          } else{
            // SI NO TIENE CORTES
            if(!daysWithoutCuts.includes(day.completeDate)){
              daysWithoutCuts.push(day.completeDate)
            }
            // chaptersWithoutCuts.push(chapter.numChapter)
          }
        })

        const durationOfDay = this.convertDurationInMinutes(totalDurationDay)
        if(durationOfDay > programDuration){
          exceedDuration.push(daySelected)
        }
      })

      if(daysWithoutCuts.length > 0){
        // if(chaptersWithoutCuts.length == 1 && chaptersWithoutCuts[0] == ''){
        //   this.validateCutsOfChapterText =  `El material debe contener cortes para poder actualizar.`
        // } else {
        this.validateCutsOfChapterText = `El(los) día(s) <strong>${daysWithoutCuts.join(', ')}</strong> debe(n) contener cortes para poder actualizar.`
        // }
        this.validateCutsOfChapter = true
        return false
      }
      
      if(exceedDuration.length > 0){
        // SI HAY DIAS QUE EXCEDEN SU DURACION NO DEBE DEJAR GUARDAR HASTA QUE LAS MODIFIQUE
        console.log(exceedDuration, 'exceedDuration')
        if(exceedDuration.length > 1){
          let days = []
          let daySeparated = ''
          exceedDuration.map((dayExceed, i)=>{
            if(i < (exceedDuration.length - 1)){
              days.push(dayExceed)
            } else{
              daySeparated = dayExceed
            }
          })
          this.durationOfDaysInvalidText = `Las duraciones de los días <strong>${days.join(', ')} y ${daySeparated}</strong> son mayores a la duración del programa.`
        } else {
          this.durationOfDaysInvalidText = `La duración del día <strong>${exceedDuration}</strong> es mayor a la duración del programa.`
        }
        this.durationOfDaysInvalid = true
      } else {
        // ACA CONTINUA EL PROCESO DE ACTUALIZAR
        this.sendEditCuts(this.objFromGrid)
      }
    },
    getTotalDuration(cuts, artisticDuration) {
      let durationOfCuts = '00:00:00'
      cuts.map((cut)=>{
        durationOfCuts = addTimes(cut.duration, durationOfCuts)
      })
      const chapterDuration = addTimes(durationOfCuts, artisticDuration)
      return chapterDuration
    },
    gettingDuration(data) {
      const {scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin} = data
      const timeStart = Number(scheduleStartHour*60)+Number(scheduleStartMin)
      const timeEnd = Number(scheduleEndHour*60)+Number(scheduleEndMin)
      const programDuration = timeEnd - timeStart
      return programDuration
    },
    convertDurationInMinutes(duration){
      const durationSeparated = duration.split(':')
      const durationConvert = Number(durationSeparated[0]*60)+Number(durationSeparated[1])
      return durationConvert
    }
  },
  watch: {
    oneDay(val) {
      if(val !== '')
        this.inputsActive = false
    }
  }
}
</script>

<style>
  .titleCuts{
    text-transform: uppercase;
    padding: 0 2rem 8px;
    border-bottom: 1.5px solid #828281;
    font-weight: 500;
    font-size: 18px;
    margin-top: 20px;
  }
  .cutIndex{
    background: #F96D2D;
    color: white;
    text-align: center;
    border-radius: 4px;
    width: 40%;
    padding: 5px;
    font-size: 14px;
    margin: auto;
  }
</style>
